
#include <windows.h>	// Gestion windows
#include <stdio.h>      // Gestion des fichiers externes
#include <string.h>     // Gestion des fichiers externes
#include <stdlib.h>     // Librairie de convertion de format
#include <commdlg.h>    // Boite de dialogue Load/Save
#include <commctrl.h>   // Pour la progressbar
#include <math.h>       // Les fonctions de math

#include "resource.h"

// TYPES USUELS /////////////////////////////////////////////////////////////////////
typedef struct
{
   FILE* file;
   struct
   {
      unsigned short audioFormat;
      unsigned short numberChannels;
      unsigned long sampleRate;
      unsigned long byteRate;
      unsigned short blockAlign;
      unsigned short bitsPerSample;
   }
   format;
   unsigned char bytesPerSample;
   unsigned long numberSamples;
}
Wave;

typedef struct
{
   FILE* file;
   signed long lastSample;
   signed short lastIndex;
}
Adpcm;


// DEFINITIONS //////////////////////////////////////////////////////////////////////
#define TAG_NO_COMPRESS    "-nocompress"
#define MAX_WAVE_FREQUENCY 22050
#define ADPCM_SAMPLES      32
#define WAVE_SAMPLES       (ADPCM_SAMPLES*2)


// PROTOTYPES ///////////////////////////////////////////////////////////////////////
char Chargement(HWND);
char Sauvegarde(HWND);

unsigned char WaveInit(Wave*);
void AdpcmEncode(Adpcm*,signed short*,unsigned char*,unsigned short);
int Convertir(HWND);


// GLOBALES /////////////////////////////////////////////////////////////////////////
HICON hIcon;
//HINSTANCE hinst;
HWND hProgress;

char FileName[256];
char FileTitle[48];
char FileFormat[3];

char FileNameSave[256];
char FileTitleSave[48];
char FileFormatSave[3];

BOOL noCompress;
BOOL binFormat=FALSE;
BOOL OptimisedMode=FALSE;

const signed char adpcmModifyIndex[8]={-1,-1,-1,-1,2,4,6,8};

const signed short adpcmStep[89]=
{
       7,    8,    9,   10,   11,   12,   13,   14,   16,
      17,   19,   21,   23,   25,   28,   31,   34,   37,
      41,   45,   50,   55,   60,   66,   73,   80,   88,
      97,  107,  118,  130,  143,  157,  173,  190,  209,
     230,  253,  279,  307,  337,  371,  408,  449,  494,
     544,  598,  658,  724,  796,  876,  963, 1060, 1166,
    1282, 1411, 1552, 1707, 1878, 2066, 2272, 2499, 2749,
    3024, 3327, 3660, 4026, 4428, 4871, 5358, 5894, 6484,
    7132, 7845, 8630, 9493,10442,11487,12635,13899,15289,
   16818,18500,20350,22385,24623,27086,29794,32767
};




