// ---------------------- Routine de la DialogBox de sauvegarde ---------------------
char Sauvegarde(HWND hwnd)
{
	lstrcpy( FileNameSave, "");
	lstrcpy( FileTitleSave, "");
	
	OPENFILENAME ofn;     
	ofn.lStructSize       = sizeof(OPENFILENAME);     
	ofn.hwndOwner         = hwnd;
	ofn.lpstrTitle        = "Enregistrement";
	ofn.lpstrFilter       = "Export pour HAM (*.asm)\0*.asm\0Export pour SDT (*.bin)\0*.bin\0";	

    #ifdef WIN32     
	  ofn.hInstance         = (HINSTANCE) GetWindowLong(hwnd, GWL_HINSTANCE);
    #else     
	  ofn.hInstance         = (HINSTANCE) GetWindowWord(hwnd, GWW_HINSTANCE);
    #endif
	      
	ofn.lpstrCustomFilter = (LPSTR) NULL;     
	ofn.nMaxCustFilter    = 0L;     
	ofn.nFilterIndex      = 1L;     
	ofn.lpstrFile         = FileNameSave;     
	ofn.nMaxFile          = sizeof(FileNameSave);     
	ofn.lpstrFileTitle    = FileTitleSave;     
	ofn.nMaxFileTitle     = sizeof(FileTitleSave);     
	ofn.lpstrInitialDir   = NULL;         
	ofn.nFileOffset       = 0;     
	ofn.nFileExtension    = 0;     
	ofn.lpstrDefExt       = ".bin";     
	ofn.lCustData         = 0; 
	
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_EXTENSIONDIFFERENT;      
	
	if (!GetSaveFileName(&ofn)) return 0;      

	strcpy(FileNameSave, ofn.lpstrFile);
	strcpy(FileTitleSave, ofn.lpstrFileTitle);
	strncpy(FileFormatSave, &FileNameSave[ofn.nFileExtension], 3);

	return 1;
}

// ---------------------- Routine de la DialogBox de chargement ---------------------
char Chargement(HWND hwnd)
{	
	lstrcpy(FileName, "");
	lstrcpy(FileTitle, "");

	OPENFILENAME ofn;           
	ofn.lStructSize       = sizeof(OPENFILENAME);     
	ofn.hwndOwner         = hwnd;
	ofn.lpstrTitle        = "Slectionner un fichier WAV";
	ofn.lpstrFilter       = "Format WAV (*.wav)\0*.wav\0";

    #ifdef WIN32     
	  ofn.hInstance       = (HINSTANCE) GetWindowLong(hwnd, GWL_HINSTANCE);
    #else     
	  ofn.hInstance       = (HINSTANCE) GetWindowWord(hwnd, GWW_HINSTANCE);
    #endif
    
	ofn.lpstrCustomFilter = (LPSTR) NULL;     
	ofn.nMaxCustFilter    = 0L;     
	ofn.nFilterIndex      = 1L;     
	ofn.lpstrFile         = FileName;     
	ofn.nMaxFile          = sizeof(FileName);     
	ofn.lpstrFileTitle    = FileTitle;     
	ofn.nMaxFileTitle     = sizeof(FileTitle);     
	ofn.lpstrInitialDir   = NULL;         
	ofn.nFileOffset       = 0;     
	ofn.nFileExtension    = 0;     
	ofn.lpstrDefExt       = NULL;     
	ofn.lCustData         = 0; 
	
	ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
	
	if (!GetOpenFileName(&ofn)) return 0;
	
	strcpy(FileName, ofn.lpstrFile);
	strcpy(FileTitle, ofn.lpstrFileTitle);
	strncpy(FileFormat, &FileName[ofn.nFileExtension], 3);

	return 1;
}

